//*****************************************************************************
//*
//*
//*		ColorListBox.cpp
//*
//*
//*****************************************************************************
// ColorListBox.cpp : Implementierungsdatei
//
#include	"StdAfx.h"
#include	"ColorListBoxApp.h"
#include	"ColorListBoxDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


#define 	 IDC_LISTBOX	0x1000
#define 	 IDC_TIMERTICK	0x1234


BEGIN_MESSAGE_MAP(CColorListBoxDlg, CDialog)
	//{{AFX_MSG_MAP(CColorListBoxDlg)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio6)
	ON_BN_CLICKED(IDC_RADIO7, OnRadio7)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio8)
	ON_BN_CLICKED(IDC_RADIO9, OnRadio9)
	ON_BN_CLICKED(IDC_RADIO10,OnRadio10)
	ON_BN_CLICKED(IDC_RADIO11,OnRadio11)
	ON_BN_CLICKED(IDC_RADIO12,OnRadio12)
	ON_BN_CLICKED(IDC_RADIO13,OnRadio13)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CHECK10,OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11,OnCheck11)
	ON_BN_CLICKED(IDC_CHECK12,OnCheck12)
	ON_BN_CLICKED(IDC_CHECK13,OnCheck13)
	ON_BN_CLICKED(IDC_CHECK14,OnCheck14)
	ON_BN_CLICKED(IDC_CHECK15,OnCheck15)
	ON_BN_CLICKED(IDC_CHECK16,OnCheck16)
	ON_BN_CLICKED(IDC_CHECK17,OnCheck17)
	ON_BN_CLICKED(IDC_CHECK18,OnCheck18)
	ON_BN_CLICKED(IDC_CHECK19,OnCheck19)
	ON_BN_CLICKED(IDC_CHECK20,OnCheck20)
	ON_LBN_SELCHANGE(IDC_LISTBOX,OnSelChanged) 
	ON_LBN_DBLCLK   (IDC_LISTBOX,OnDoubleClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  CColorListBoxDlg Dialogfeld
CColorListBoxDlg::CColorListBoxDlg(CWnd *pParent): CDialog(CColorListBoxDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CColorListBoxDlg)
	m_iSelected  	 = 2;
	m_iTextColor 	 = 0;
	m_iTabSize	 	 = 0;
	m_iBgColor   	 = 0;
	m_bVarFont		 = TRUE;
	m_bSelectionMark = TRUE;
	m_bAlternated 	 = FALSE;
	m_bHasLines	  	 = FALSE;
	m_bHasSelect	 = FALSE;	
	m_bHasCursor	 = FALSE;
	m_bDblclkSel	 = FALSE;
	m_bWordSelection = FALSE;
	m_bStepMisc		 = FALSE;	
	m_bStepFirst	 = FALSE;
	m_bStepUpper	 = FALSE;
	m_bUseIcons		 = FALSE;
	m_bUseOverlay	 = FALSE;
	m_bNoContext	 = FALSE;
	m_bCallback		 = FALSE;
	m_bIdentOn		 = FALSE;
	m_bSelMarkOff	 = FALSE;
	m_bMultiFont	 = FALSE;
	m_bNoScroll		 = FALSE;
	//}}AFX_DATA_INIT

	m_hIcon			 = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwFlags		 = 0;
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CColorListBoxDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CColorListBoxDlg)
	DDX_Radio(pDX, IDC_RADIO8,  m_iBgColor);
	DDX_Radio(pDX, IDC_RADIO1,  m_iSelected);
	DDX_Radio(pDX, IDC_RADIO5,  m_iTextColor);
	DDX_Radio(pDX, IDC_RADIO11, m_iTabSize);
	DDX_Check(pDX, IDC_CHECK1,  m_bSelectionMark);
	DDX_Check(pDX, IDC_CHECK2,  m_bVarFont);
	DDX_Check(pDX, IDC_CHECK3,  m_bAlternated);
	DDX_Check(pDX, IDC_CHECK4,  m_bHasLines);
	DDX_Check(pDX, IDC_CHECK5,  m_bHasSelect);
	DDX_Check(pDX, IDC_CHECK6,  m_bHasCursor);
	DDX_Check(pDX, IDC_CHECK7,  m_bWordSelection);
	DDX_Check(pDX, IDC_CHECK8,  m_bDblclkSel);
	DDX_Check(pDX, IDC_CHECK9,  m_bStepMisc);
	DDX_Check(pDX, IDC_CHECK10, m_bStepFirst);
	DDX_Check(pDX, IDC_CHECK11, m_bStepUpper);
	DDX_Check(pDX, IDC_CHECK12, m_bStepUnter);
	DDX_Check(pDX, IDC_CHECK13, m_bUseIcons);
	DDX_Check(pDX, IDC_CHECK14, m_bUseOverlay);
	DDX_Check(pDX, IDC_CHECK15, m_bNoContext);
	DDX_Check(pDX, IDC_CHECK16, m_bCallback);
	DDX_Check(pDX, IDC_CHECK17, m_bIdentOn);
	DDX_Check(pDX, IDC_CHECK18, m_bSelMarkOff);
	DDX_Check(pDX, IDC_CHECK19, m_bMultiFont);
	DDX_Check(pDX, IDC_CHECK20, m_bNoScroll);
	//}}AFX_DATA_MAP

}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  CColorListBoxDlg Nachrichten-Handler
BOOL CColorListBoxDlg::OnInitDialog()
{
TCHAR	   *pSufix [4]={_T(""),_T("   Hello"),_T("   ThisIsForTesting _abc_ 1234 ++++ xyz"),_T("   0123456789 0123456789 0123456789 0123456789 0123456789 ")};
TCHAR		cText  [1024];
BYTE		bColors[1024];
CMenu	   *pSysMenu;
CWnd       *pWnd;
CRect		sRect;
POINT		sPoint;
int			iLine;
int			iBits;
int			iPos;
int			iOff;
int			iLen;


	sPoint.x = 0;
	sPoint.y = 0;

	pWnd =GetDlgItem(IDC_FRAME);
	pWnd->GetWindowRect (&sRect );
		  ClientToScreen(&sPoint);

	sRect.left	   -= sPoint.x;
	sRect.right    -= sPoint.x;
	sRect.top	   -= sPoint.y;
	sRect.bottom   -= sPoint.y;


	m_cListBox.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|LBS_MULTIPLESEL,sRect,this,IDC_LISTBOX);
	m_cListBox.SetColor( 4,RGB(  0,  0,  0));
	m_cListBox.SetColor( 5,RGB(  0,  0,128));
	m_cListBox.SetColor( 6,RGB(  0,128,  0));
	m_cListBox.SetColor( 7,RGB(  0,128,128));
	m_cListBox.SetColor( 8,RGB(128,  0,  0));
	m_cListBox.SetColor( 9,RGB(128,  0,128));
	m_cListBox.SetColor(10,RGB(128,128,  0));
	m_cListBox.SetColor(11,RGB(128,128,128));
	m_cListBox.SetColor(12,RGB(192,192,192));
	m_cListBox.SetColor(13,RGB(  0,  0,255));
	m_cListBox.SetColor(14,RGB(  0,255,  0));
	m_cListBox.SetColor(15,RGB(  0,255,255));
	m_cListBox.SetColor(16,RGB(255,  0,  0));
	m_cListBox.SetColor(17,RGB(255,  0,255));
	m_cListBox.SetColor(18,RGB(255,255,  0));
	m_cListBox.SetColor(19,RGB(255,128,128));
	m_cListBox.SetFont    (m_bVarFont);
	m_cListBox.SetMarkType(m_iSelected);
	m_cListBox.SetMarkMode(m_bSelectionMark);


	m_cChecks .Create(IDB_CHECKS,16,8,RGB(0,255,255));
	m_cMyIcons.Create(IDB_ICONS ,16,8,RGB(0,255,255));



	memset(bColors,0,sizeof(bColors));

	for(iLine=0;iLine<100;iLine++)						// Zeilen einfgen
		{
		iOff = _stprintf(cText,_T("Line %02i\t\t"),iLine);
		memset(bColors,0,iOff);
		
		for(iPos=4;iPos<CLB_MAX_COLOR;iPos++)
			{
			if(iOff+5>=sizeof(cText))break;
			iLen = _stprintf(cText  +iOff,_T("C%02i "),iPos);

			if(iPos>=17 && iPos<=24)
				{
				iBits = (iPos-17)<<5;
				}
			else{
				iBits = 0;
				}

			memset(bColors+iOff,iPos|iBits,iLen);
			iOff += iLen;
			}
		
		_tcscat(cText,pSufix[iLine&3]);
		m_cListBox.AddString(cText,bColors);

		m_cListBox.SetItemData(iLine,iLine);
		m_cListBox.SetItemState(iLine,CLBS_ICON_SET(iLine%2)|(iLine&2),CLBS_ICON_MASK|CLBS_OVERLAY);

		if(iLine%8==7)
			{
			m_cListBox.EnableSel(iLine,FALSE);
			m_cListBox.SetItemIcon(iLine,2);
			}
		}

	

	m_cListBox.SetCurSel(4);
	
	
	CDialog::OnInitDialog();


	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT( IDM_ABOUTBOX < 0xF000);



	   pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu!=NULL)
		{
		CString		sAboutMenu;

		sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, sAboutMenu);
			}
		}

	SetTimer(IDC_TIMERTICK,1000,NULL);
	SetIcon(m_hIcon,TRUE );
	SetIcon(m_hIcon,FALSE);
	OnSelChanged();



return TRUE;
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CColorListBoxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	if((nID&0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog	sDlg(IDD_ABOUTBOX);
		
		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}

}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
//  Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// 	den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// 	Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CColorListBoxDlg::OnPaint()
{
	if(IsIconic())
		{
		CPaintDC dc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CColorListBoxDlg::OnQueryDragIcon()
{

return (HCURSOR) m_hIcon;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CColorListBoxDlg::OnOK()
{

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CColorListBoxDlg::OnCancel()
{

	CDialog::OnCancel();
}


//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CColorListBoxDlg::OnRadio1(){OnRadio(0);} 
void CColorListBoxDlg::OnRadio2(){OnRadio(1);}  
void CColorListBoxDlg::OnRadio3(){OnRadio(2);}  
void CColorListBoxDlg::OnRadio4(){OnRadio(3);}  
void CColorListBoxDlg::OnRadio(int iNum)
{
	UpdateData();
	m_cListBox.SetMarkType(m_iSelected);
}



//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CColorListBoxDlg::OnRadio5(){OnTextColor(0);} 
void CColorListBoxDlg::OnRadio6(){OnTextColor(1);}  
void CColorListBoxDlg::OnRadio7(){OnTextColor(2);}  
void CColorListBoxDlg::OnTextColor(int iNum)
{
COLORREF	uColor=0xFFFFFFFF;

	UpdateData();
	
	if(m_iTextColor==0)m_cListBox.SetColor(0,RGB(  0,  0,  0));
	if(m_iTextColor==1)m_cListBox.SetColor(0,RGB(  0,  0,255));
	if(m_iTextColor==2)m_cListBox.SetColor(0,RGB(255,  0,  0));

}


//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CColorListBoxDlg::OnRadio8 (){OnBgColor(0);} 
void CColorListBoxDlg::OnRadio9 (){OnBgColor(1);}  
void CColorListBoxDlg::OnRadio10(){OnBgColor(2);}  
void CColorListBoxDlg::OnBgColor(int iNum)
{
COLORREF	uColor1=0xFFFFFFFF;
COLORREF	uColor2=0xFFFFFFFF;


	UpdateData();

	if(m_iBgColor==0)uColor1=0xFFFFFFFF;
	if(m_iBgColor==1)uColor1=RGB(255,255,202);
	if(m_iBgColor==2)uColor1=RGB(232,255,232);

	if(m_iBgColor==0)uColor2=0xFFFFFFFF;
	if(m_iBgColor==1)uColor2=RGB(255,255,232);
	if(m_iBgColor==2)uColor2=RGB(248,255,248);

	m_cListBox.SetColor(CLB_COLOR_EVEN,0xFFFFFFFF,uColor1);
	m_cListBox.SetColor(CLB_COLOR_ODD ,0xFFFFFFFF,uColor2);

}

//*****************************************************************************
//*
//*		OnRadio?
//*
//*****************************************************************************
void CColorListBoxDlg::OnRadio11(){OnTabulator(0);} 
void CColorListBoxDlg::OnRadio12(){OnTabulator(1);}  
void CColorListBoxDlg::OnRadio13(){OnTabulator(2);}  
void CColorListBoxDlg::OnTabulator(int iNum)
{

	UpdateData();
	
	if(m_iTabSize==0)m_cListBox.SetTabSize(  4);
	if(m_iTabSize==1)m_cListBox.SetTabSize(  8);
	if(m_iTabSize==2)m_cListBox.SetTabSize(-80);

}



//*****************************************************************************
//*
//*		OnCheck1
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck1() 
{

	UpdateData();
	
	m_cListBox.SetMarkMode(m_bSelectionMark);

}


//*****************************************************************************
//*
//*		OnCheck2
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck2() 
{

	UpdateData();
	
	m_cListBox.SetFont(m_bVarFont);

}


//*****************************************************************************
//*
//*		OnCheck3
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck3() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bAlternated)? CLB_FLAG_ALTERNATED:0,CLB_FLAG_ALTERNATED);

}


//*****************************************************************************
//*
//*		OnCheck4
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck4() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bHasLines)? CLB_FLAG_LINES:0,CLB_FLAG_LINES);

}


//*****************************************************************************
//*
//*		OnCheck5
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck5() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bHasSelect)? CLB_FLAG_SELFIELD|CLB_FLAG_SELSPACE|CLB_FLAG_SELRETURN:0,CLB_FLAG_SELFIELD|CLB_FLAG_SELSPACE|CLB_FLAG_SELRETURN);

	GetDlgItem(IDC_CHECK14)->EnableWindow(m_bHasSelect);

}

//*****************************************************************************
//*
//*		OnCheck6
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck6() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bHasCursor)? CLB_FLAG_CURSOR:0,CLB_FLAG_CURSOR);
	if(m_bHasCursor)m_cListBox.SetFocus();

	GetDlgItem(IDC_CHECK9 )->EnableWindow(m_bHasCursor);
	GetDlgItem(IDC_CHECK10)->EnableWindow(m_bHasCursor);
	GetDlgItem(IDC_CHECK11)->EnableWindow(m_bHasCursor);
	GetDlgItem(IDC_CHECK12)->EnableWindow(m_bHasCursor);

}

//*****************************************************************************
//*
//*		OnCheck7
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck7() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bWordSelection)? CLB_FLAG_WORDDBLCLK:0,CLB_FLAG_WORDDBLCLK);

}

//*****************************************************************************
//*
//*		OnCheck8
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck8() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bDblclkSel)? CLB_FLAG_SELDBLCLK:0,CLB_FLAG_SELDBLCLK);

}

//*****************************************************************************
//*
//*		OnCheck9
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck9() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bStepMisc)? CLB_FLAG_STEPMISC:0,CLB_FLAG_STEPMISC);

}

//*****************************************************************************
//*
//*		OnCheck10
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck10() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bStepFirst)? CLB_FLAG_STEPFIRST:0,CLB_FLAG_STEPFIRST);

}

//*****************************************************************************
//*
//*		OnCheck11
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck11() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bStepUpper)? CLB_FLAG_STEPUPPER:0,CLB_FLAG_STEPUPPER);

}

//*****************************************************************************
//*
//*		OnCheck12
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck12() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bStepUnter)? CLB_FLAG_STEPUNTER:0,CLB_FLAG_STEPUNTER);

}

//*****************************************************************************
//*
//*		OnCheck13
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck13() 
{

	UpdateData();
	
	m_cListBox.SetImageList((m_bUseIcons)? &m_cMyIcons:NULL,CLBIL_ICONS|CLBIL_NOTDEL);

}

//*****************************************************************************
//*
//*		OnCheck14
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck14() 
{

	UpdateData();
	
	m_cListBox.SetImageList((m_bUseOverlay)? &m_cChecks:NULL,CLBIL_STATE|CLBIL_NOTDEL);

}

//*****************************************************************************
//*
//*		OnCheck15
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck15() 
{

	UpdateData();
	
	m_cListBox.SetFlags((m_bNoContext)? CLB_FLAG_NOCONTEXT:0,CLB_FLAG_NOCONTEXT);

}

//*****************************************************************************
//*
//*		OnCheck16
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck16() 
{

	UpdateData();
	
	m_cListBox.SetLineCallback((m_bCallback)? LineCallback:NULL);
	m_cListBox.RedrawWindow();

}


//*****************************************************************************
//*
//*		OnCheck17
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck17() 
{
int		iLine;


	UpdateData();

	for(iLine=0;iLine<100;iLine+=5)						
		{
		m_cListBox.SetItemIdent(iLine,((m_bIdentOn)? 10:0)|CLB_NOUPDATE);
		}
	
	m_cListBox.RedrawWindow();

}

//*****************************************************************************
//*
//*		OnCheck18
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck18() 
{

	UpdateData();
	
	m_cListBox.SetExtendedStyle((m_bSelMarkOff)? 0:CLB_EX_SELMARK,CLB_EX_SELMARK);
	m_cListBox.RedrawWindow();

}

//*****************************************************************************
//*
//*		OnCheck19
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck19() 
{

	UpdateData();
	
	m_cListBox.SetExtendedStyle((m_bMultiFont)? CLB_EX_MULITFONT:0,CLB_EX_MULITFONT);
	m_cListBox.RedrawWindow();

}

//*****************************************************************************
//*
//*		OnCheck20
//*
//*****************************************************************************
void CColorListBoxDlg::OnCheck20() 
{

	UpdateData();

	m_cListBox.SetStyle((m_bNoScroll)? CLBS_NOSCROLLX:0,CLBS_NOSCROLLX);
	m_cListBox.RedrawWindow();

}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void CColorListBoxDlg::OnSelChanged()
{
TCHAR	cText[256];


	_stprintf(cText,_T("%i"),m_cListBox.GetCurSel());
	GetDlgItem(IDC_EDIT1)->SetWindowText(cText);
}

	

//*****************************************************************************
//*
//*		OnDoubleClick
//*
//*****************************************************************************
void CColorListBoxDlg::OnDoubleClick()
{

	MessageBox(_T("Double Click"),_T("Info"),MB_OK|MB_ICONINFORMATION);

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CColorListBoxDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent==IDC_TIMERTICK)
		{
		/*
		TCHAR	cText[256];
		int		i=0,j=0,l=0,m=0,n=0;

		i=m_cListBox.GetMark(j,l,m,n);

		_stprintf(cText,_T("%i=%i,%i,%i,%i"),i,j,l,m,n);
		GetDlgItem(IDC_EDIT1)->SetWindowText(cText);
		//*/

		return;
		}

	CDialog::OnTimer(nIDEvent);
}


//*****************************************************************************
//*
//*		LineCallback
//*
//*****************************************************************************
//	Callback fr den Text der einzelnen Zeilen und Spalten
void CALLBACK CColorListBoxDlg::LineCallback(HWND hWnd,LPARAM lItem,CLB_ENTRY *pEntry,LPVOID pParam)
{
static	BYTE	aColors[1024];
static	int		iInit=0;

	if(!iInit)
		{
		for(iInit=0;iInit<sizeof(aColors);iInit++)
			{
			aColors[iInit] = (iInit/4)%16;
			if(aColors[iInit])aColors[iInit]+=4;
			}

		}

	pEntry->iSize  = _stprintf(pEntry->pText,_T("Line %i\t\t%.*s"),lItem,lItem&0xFF,_T("XX YY ZZ ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* ********* "));
	pEntry->pColor = aColors+(lItem&0xFF);


}

