//*****************************************************************************
//*
//*
//*		ColorListBoxDlg.h
//*
//*
//*****************************************************************************
#ifndef		AFX_COLORLISTBOX_H__1C144421_AAB9_45FB_9374_8AF13E8FE36B__INCLUDED_
#define		AFX_COLORLISTBOX_H__1C144421_AAB9_45FB_9374_8AF13E8FE36B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif


#include	"ColorListBox.h"


//*****************************************************************************
//*
//*		CColorListBoxDlg Dialogfeld
//*
//*****************************************************************************
class CColorListBoxDlg : public CDialog
{
	// Konstruktion
public:
	CColorListBoxDlg(CWnd *pParent = NULL); 					// Standard-Konstruktor

	//{{AFX_DATA(CColorListBoxDlg)
	enum { IDD = IDD_COLORLISTBOX_DIALOG };
	int		m_iSelected;
	int		m_iBgColor;
	int		m_iTabSize;
	int		m_iTextColor;
	BOOL	m_bSelectionMark;
	BOOL	m_bVarFont;
	BOOL	m_bHasLines;
	BOOL	m_bHasSelect;
	BOOL	m_bAlternated;
	BOOL	m_bHasCursor;
	BOOL	m_bWordSelection;
	BOOL	m_bDblclkSel;
	BOOL	m_bStepMisc;
	BOOL	m_bStepFirst;
	BOOL	m_bStepUpper;
	BOOL	m_bStepUnter;
	BOOL	m_bUseIcons;
	BOOL	m_bUseOverlay;
	BOOL	m_bNoContext;
	BOOL	m_bCallback;
	BOOL	m_bIdentOn;
	BOOL	m_bSelMarkOff;
	BOOL	m_bMultiFont;
	BOOL	m_bNoScroll;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CColorListBoxDlg)
protected:
	virtual void DoDataExchange(CDataExchange *pDX);			// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

protected:

	HICON			m_hIcon;
	DWORD			m_dwFlags;
	CImageList		m_cChecks;
	CImageList		m_cMyIcons;
	CColorListBox	m_cListBox;

	//{{AFX_MSG(CColorListBoxDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	afx_msg void OnRadio3();
	afx_msg void OnRadio4();
	afx_msg void OnRadio5();
	afx_msg void OnRadio6();
	afx_msg void OnRadio7();
	afx_msg void OnRadio8();
	afx_msg void OnRadio9();
	afx_msg void OnRadio10();
	afx_msg void OnRadio11();
	afx_msg void OnRadio12();
	afx_msg void OnRadio13();
	afx_msg void OnCheck1();
	afx_msg void OnCheck2();
	afx_msg void OnCheck3();
	afx_msg void OnCheck4();
	afx_msg void OnCheck5();
	afx_msg void OnCheck6();
	afx_msg void OnCheck7();
	afx_msg void OnCheck8();
	afx_msg void OnCheck9();
	afx_msg void OnCheck10();
	afx_msg void OnCheck11();
	afx_msg void OnCheck12();
	afx_msg void OnCheck13();
	afx_msg void OnCheck14();
	afx_msg void OnCheck15();
	afx_msg void OnCheck16();
	afx_msg void OnCheck17();
	afx_msg void OnCheck18();
	afx_msg void OnCheck19();
	afx_msg void OnCheck20();
	afx_msg void OnTimer(UINT_PTR);
	afx_msg void OnSelChanged(); 
	afx_msg void OnDoubleClick();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void OnRadio(int iNum);
	void OnBgColor(int iNum);
	void OnTabulator(int iNum);
	void OnTextColor(int iNum);
	
	static void CALLBACK LineCallback(HWND hWnd,LPARAM lItem,CLB_ENTRY *pEntry,LPVOID pParam);
};	

//{{AFX_INSERT_LOCATION}}

#endif
